	.file	"nano_os.c"
__SREG__ = 0x3f
__SP_H__ = 0x3e
__SP_L__ = 0x3d
__tmp_reg__ = 0
__zero_reg__ = 1
	.global __do_copy_data
	.global __do_clear_bss
	.text
.global	scheduler
	.type	scheduler, @function
scheduler:
/* prologue: frame size=0 */
/* prologue: naked */
/* prologue end (size=0) */
	lds r30,active_task
	lds r31,(active_task)+1
	sbiw r30,0
	breq .L2
	in r18,93-0x20
	in r19,(93)+1-0x20
	ldd r24,Z+6
	ldd r25,Z+7
	cp r18,r24
	cpc r19,r25
	brlo .L4
	in r18,93-0x20
	in r19,(93)+1-0x20
	ldd r24,Z+6
	ldd r25,Z+7
	subi r24,lo8(-(96))
	sbci r25,hi8(-(96))
	cp r18,r24
	cpc r19,r25
	brlo .L2
.L4:
	ldi r24,lo8(24)
	ldi r25,hi8(24)
	ldi r18,lo8(14)
/* #APP */
	in __tmp_reg__,__SREG__
	cli
	wdr
	sts 96,r24
	out __SREG__,__tmp_reg__
	sts 96,r18
	
/* #NOAPP */
.L6:
	rjmp .L6
.L2:
	ldi r24,lo8(5)
	out 69-0x20,r24
	lds r24,active_task_id
	sbrc r24,7
	rjmp .L13
/* #APP */
	push r31
	push r30
	push r29
	push r28
	push r27
	push r26
	push r25
	push r24
	push r23
	push r22
	push r21
	push r20
	push r19
	push r18
	push r17
	push r16
	push r15
	push r14
	push r13
	push r12
	push r11
	push r10
	push r9
	push r8
	push r7
	push r6
	push r5
	push r4
	push r3
	push r2
	push r1
	push r0
/* #NOAPP */
	in r24,95-0x20
	std Z+3,r24
	in r24,93-0x20
	in r25,(93)+1-0x20
	adiw r24,32
	std Z+5,r25
	std Z+4,r24
.L13:
	lds r24,active_task_id
	subi r24,lo8(-(1))
	sts active_task_id,r24
	lds r24,active_task_id
	cpi r24,lo8(4)
	brlt .L9
	sts active_task_id,__zero_reg__
.L9:
	lds r30,active_task_id
	clr r31
	sbrc r30,7
	com r31
	lsl r30
	rol r31
	subi r30,lo8(-(task_container))
	sbci r31,hi8(-(task_container))
	ld __tmp_reg__,Z+
	ld r31,Z
	mov r30,__tmp_reg__
	sbiw r30,0
	breq .L13
	sts (active_task)+1,r31
	sts active_task,r30
	ldd r24,Z+1
	ldd r25,Z+2
	out 70-0x20,r24
	ldd r24,Z+3
	out 95-0x20,r24
	ldd r24,Z+4
	ldd r25,Z+5
	sbiw r24,32
	out (93)+1-0x20,r25
	out 93-0x20,r24
/* #APP */
	pop r0
	pop r1
	pop r2
	pop r3
	pop r4
	pop r5
	pop r6
	pop r7
	pop r8
	pop r9
	pop r10
	pop r11
	pop r12
	pop r13
	pop r14
	pop r15
	pop r16
	pop r17
	pop r18
	pop r19
	pop r20
	pop r21
	pop r22
	pop r23
	pop r24
	pop r25
	pop r26
	pop r27
	pop r28
	pop r29
	pop r30
	pop r31
	reti
/* #NOAPP */
/* epilogue: frame size=0 */
/* epilogue: naked */
/* epilogue end (size=0) */
/* function scheduler size 222 (222) */
	.size	scheduler, .-scheduler
.global	__vector_16
	.type	__vector_16, @function
__vector_16:
/* prologue: frame size=0 */
	push __zero_reg__
	push __tmp_reg__
	in __tmp_reg__,__SREG__
	push __tmp_reg__
	clr __zero_reg__
	push r18
	push r19
	push r20
	push r21
	push r22
	push r23
	push r24
	push r25
	push r26
	push r27
	push r30
	push r31
/* prologue end (size=17) */
	call scheduler
/* epilogue: frame size=0 */
	pop r31
	pop r30
	pop r27
	pop r26
	pop r25
	pop r24
	pop r23
	pop r22
	pop r21
	pop r20
	pop r19
	pop r18
	pop __tmp_reg__
	out __SREG__,__tmp_reg__
	pop __tmp_reg__
	pop __zero_reg__
	reti
/* epilogue end (size=17) */
/* function __vector_16 size 36 (2) */
	.size	__vector_16, .-__vector_16
.global	reset_system
	.type	reset_system, @function
reset_system:
/* prologue: frame size=0 */
/* prologue end (size=0) */
/* #APP */
	cli
/* #NOAPP */
	ldi r24,lo8(24)
	ldi r25,hi8(24)
	ldi r18,lo8(14)
/* #APP */
	in __tmp_reg__,__SREG__
	cli
	wdr
	sts 96,r24
	out __SREG__,__tmp_reg__
	sts 96,r18
	
/* #NOAPP */
.L19:
	rjmp .L19
/* epilogue: frame size=0 */
/* epilogue: noreturn */
/* epilogue end (size=0) */
/* function reset_system size 20 (20) */
	.size	reset_system, .-reset_system
.global	task_insert
	.type	task_insert, @function
task_insert:
/* prologue: frame size=0 */
	push r28
	push r29
/* prologue end (size=2) */
	movw r26,r24
	in r24,95-0x20
	sts sregsys,r24
/* #APP */
	cli
/* #NOAPP */
	ldi r30,lo8(task_container)
	ldi r31,hi8(task_container)
	ldi r28,lo8(0)
	ldi r29,hi8(0)
.L22:
	ld r24,Z
	ldd r25,Z+1
	or r24,r25
	brne .L23
	st X,r28
	movw r30,r26
	std Z+2,r21
	std Z+1,r20
	ldi r24,lo8(96)
	ldi r25,hi8(96)
	movw r18,r24
	mul r28,r18
	movw r24,r0
	mul r28,r19
	add r25,r0
	mul r29,r18
	add r25,r0
	clr r1
	subi r24,lo8(-(stack_global))
	sbci r25,hi8(-(stack_global))
	std Z+7,r25
	std Z+6,r24
	ldd r18,Z+6
	ldd r19,Z+7
	subi r18,lo8(-(93))
	sbci r19,hi8(-(93))
	ldi r24,lo8(93)
.L25:
	movw r30,r18
	st Z,__zero_reg__
	subi r18,lo8(-(-1))
	sbci r19,hi8(-(-1))
	subi r24,1
	brcc .L25
	movw r30,r26
	ldd r18,Z+6
	ldd r19,Z+7
	subi r18,lo8(-(94))
	sbci r19,hi8(-(94))
	mov r24,r23
	clr r25
	movw r30,r18
	st Z,r24
	movw r30,r26
	ldd r24,Z+6
	ldd r25,Z+7
	subi r24,lo8(-(95))
	sbci r25,hi8(-(95))
	movw r30,r24
	st Z,r22
	movw r30,r26
	ldd r24,Z+6
	ldd r25,Z+7
	subi r24,lo8(-(93))
	sbci r25,hi8(-(93))
	std Z+5,r25
	std Z+4,r24
	std Z+3,__zero_reg__
	lsl r28
	rol r29
	subi r28,lo8(-(task_container))
	sbci r29,hi8(-(task_container))
	std Y+1,r27
	st Y,r26
	rjmp .L27
.L23:
	adiw r28,1
	adiw r30,2
	cpi r28,4
	cpc r29,__zero_reg__
	breq .+2
	rjmp .L22
.L27:
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(1)
	ldi r25,hi8(1)
/* epilogue: frame size=0 */
	pop r29
	pop r28
	ret
/* epilogue end (size=3) */
/* function task_insert size 91 (86) */
	.size	task_insert, .-task_insert
.global	task_remove
	.type	task_remove, @function
task_remove:
/* prologue: frame size=0 */
	push r28
	push r29
/* prologue end (size=2) */
	movw r30,r24
	in r24,95-0x20
	sts sregsys,r24
/* #APP */
	cli
/* #NOAPP */
	ld r21,Z
	tst r21
	brne .L33
	lds r24,sregsys
	out 95-0x20,r24
	rjmp .L52
.L33:
	mov r22,r21
	clr r23
	lds r24,active_task_id
	clr r25
	sbrc r24,7
	com r25
	cp r22,r24
	cpc r23,r25
	brne .L36
	sts (active_task)+1,__zero_reg__
	sts active_task,__zero_reg__
.L36:
	movw r30,r22
	lsl r30
	rol r31
	subi r30,lo8(-(task_container))
	sbci r31,hi8(-(task_container))
	std Z+1,__zero_reg__
	st Z,__zero_reg__
	ldi r28,lo8(0)
	ldi r29,hi8(0)
	rjmp .L38
.L39:
	ldi r24,lo8(3)
	mul r25,r24
	movw r30,r0
	clr r1
	subi r30,lo8(-(blocks))
	sbci r31,hi8(-(blocks))
	ld r24,Z
	cp r24,r21
	brne .L40
	std Z+2,__zero_reg__
	std Z+1,__zero_reg__
	st Z,__zero_reg__
	mov r20,r28
	rjmp .L42
.L43:
	movw r24,r18
	adiw r24,1
	movw r26,r18
	lsl r26
	rol r27
	add r26,r18
	adc r27,r19
	movw r30,r24
	lsl r30
	rol r31
	add r30,r24
	adc r31,r25
	subi r26,lo8(-(blocks))
	sbci r27,hi8(-(blocks))
	subi r30,lo8(-(blocks))
	sbci r31,hi8(-(blocks))
	ldi r24,lo8(3)
.L44:
	ld r0,Z+
	st X+,r0
	subi r24,lo8(-(-1))
	brne .L44
	subi r20,lo8(-(1))
.L42:
	mov r18,r20
	clr r19
	lds r24,activeBlocks
	clr r25
	sbiw r24,1
	cp r18,r24
	cpc r19,r25
	brlt .L43
	lds r24,activeBlocks
	subi r24,lo8(-(-1))
	sts activeBlocks,r24
.L40:
	adiw r28,1
.L38:
	mov r25,r28
	lds r24,activeBlocks
	cp r28,r24
	brlo .L39
	lds r24,active_task_id
	clr r25
	sbrc r24,7
	com r25
	cp r22,r24
	cpc r23,r25
	breq .L47
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(1)
	ldi r25,hi8(1)
	rjmp .L35
.L47:
	ldi r24,lo8(1)
	out 69-0x20,r24
	ldi r24,lo8(-1)
	out 70-0x20,r24
	sts active_task_id,r24
	in r24,83-0x20
	andi r24,lo8(-15)
	out 83-0x20,r24
/* #APP */
	sei
/* #NOAPP */
	in r24,83-0x20
	ori r24,lo8(1)
	out 83-0x20,r24
/* #APP */
	sleep
	
/* #NOAPP */
	in r24,83-0x20
	andi r24,lo8(-2)
	out 83-0x20,r24
.L52:
	ldi r24,lo8(0)
	ldi r25,hi8(0)
.L35:
/* epilogue: frame size=0 */
	pop r29
	pop r28
	ret
/* epilogue end (size=3) */
/* function task_remove size 136 (131) */
	.size	task_remove, .-task_remove
.global	task_schedule
	.type	task_schedule, @function
task_schedule:
/* prologue: frame size=0 */
/* prologue end (size=0) */
/* #APP */
	cli
/* #NOAPP */
	in r24,83-0x20
	andi r24,lo8(-15)
	out 83-0x20,r24
	ldi r24,lo8(-1)
	out 70-0x20,r24
	ldi r24,lo8(1)
	out 69-0x20,r24
	ldi r30,lo8(110)
	ldi r31,hi8(110)
	ld r24,Z
	ori r24,lo8(1)
	st Z,r24
/* #APP */
	sei
/* #NOAPP */
	in r24,83-0x20
	ori r24,lo8(1)
	out 83-0x20,r24
/* #APP */
	sleep
	
/* #NOAPP */
	in r24,83-0x20
	andi r24,lo8(-2)
	out 83-0x20,r24
/* epilogue: frame size=0 */
	ret
/* epilogue end (size=1) */
/* function task_schedule size 27 (26) */
	.size	task_schedule, .-task_schedule
.global	taskNewPrio
	.type	taskNewPrio, @function
taskNewPrio:
/* prologue: frame size=0 */
/* prologue end (size=0) */
	lds r30,active_task
	lds r31,(active_task)+1
	std Z+2,r25
	std Z+1,r24
	ldd r24,Z+1
	ldd r25,Z+2
	clr r25
/* epilogue: frame size=0 */
	ret
/* epilogue end (size=1) */
/* function taskNewPrio size 10 (9) */
	.size	taskNewPrio, .-taskNewPrio
.global	idle
	.type	idle, @function
idle:
/* prologue: frame size=0 */
/* prologue end (size=0) */
.L59:
/* #APP */
	wdr
/* #NOAPP */
	in r24,83-0x20
	andi r24,lo8(-15)
	out 83-0x20,r24
	ldi r24,lo8(1)
	out 69-0x20,r24
	ldi r24,lo8(-1)
	out 70-0x20,r24
	in r24,83-0x20
	ori r24,lo8(1)
	out 83-0x20,r24
/* #APP */
	sleep
	
/* #NOAPP */
	in r24,83-0x20
	andi r24,lo8(-2)
	out 83-0x20,r24
	rjmp .L59
/* epilogue: frame size=0 */
/* epilogue: noreturn */
/* epilogue end (size=0) */
/* function idle size 20 (20) */
	.size	idle, .-idle
.global	memory_get_free_blocks
	.type	memory_get_free_blocks, @function
memory_get_free_blocks:
/* prologue: frame size=0 */
/* prologue end (size=0) */
	lds r25,activeBlocks
	ldi r24,lo8(2)
	sub r24,r25
	clr r25
/* epilogue: frame size=0 */
	ret
/* epilogue end (size=1) */
/* function memory_get_free_blocks size 6 (5) */
	.size	memory_get_free_blocks, .-memory_get_free_blocks
.global	memory_allocate_block
	.type	memory_allocate_block, @function
memory_allocate_block:
/* prologue: frame size=0 */
	push r28
	push r29
/* prologue end (size=2) */
	in r24,95-0x20
	sts sregsys,r24
/* #APP */
	cli
/* #NOAPP */
	lds r24,activeBlocks
	cpi r24,lo8(2)
	brsh .L67
	lds r25,activeBlocks
	ldi r24,lo8(3)
	mul r25,r24
	movw r30,r0
	clr r1
	subi r30,lo8(-(blocks))
	sbci r31,hi8(-(blocks))
	lds r24,activeBlocks
	clr r25
	lsl r24
	rol r25
	subi r24,lo8(-(data))
	sbci r25,hi8(-(data))
	std Z+2,r25
	std Z+1,r24
	ldd r26,Z+1
	ldd r27,Z+2
	ldd r24,Z+1
	ldd r25,Z+2
	or r24,r25
	breq .L67
	ldd r24,Z+1
	ldd r25,Z+2
	subi r24,lo8(768)
	sbci r25,hi8(768)
	brlo .L69
.L67:
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(0)
	ldi r25,hi8(0)
	rjmp .L66
.L69:
	st X,__zero_reg__
	movw r28,r26
	std Y+1,__zero_reg__
	lds r24,active_task_id
	st Z,r24
	lds r24,activeBlocks
	subi r24,lo8(-(1))
	sts activeBlocks,r24
	lds r24,sregsys
	out 95-0x20,r24
	ldd r24,Z+1
	ldd r25,Z+2
.L66:
/* epilogue: frame size=0 */
	pop r29
	pop r28
	ret
/* epilogue end (size=3) */
/* function memory_allocate_block size 65 (60) */
	.size	memory_allocate_block, .-memory_allocate_block
.global	memory_free_block
	.type	memory_free_block, @function
memory_free_block:
/* prologue: frame size=0 */
/* prologue end (size=0) */
	movw r18,r24
	in r24,95-0x20
	sts sregsys,r24
/* #APP */
	cli
/* #NOAPP */
	ldi r20,lo8(0)
	ldi r21,hi8(0)
	rjmp .L72
.L73:
	ldi r24,lo8(3)
	mul r22,r24
	movw r30,r0
	clr r1
	subi r30,lo8(-(blocks))
	sbci r31,hi8(-(blocks))
	ldd r24,Z+1
	ldd r25,Z+2
	subi r20,lo8(-(1))
	sbci r21,hi8(-(1))
	cp r24,r18
	cpc r25,r19
	breq .+2
	rjmp .L72
	ld r18,Z
	lds r24,active_task_id
	clr r19
	clr r25
	sbrc r24,7
	com r25
	cp r18,r24
	cpc r19,r25
	breq .L75
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(0)
	ldi r25,hi8(0)
	ret
.L75:
	std Z+2,__zero_reg__
	std Z+1,__zero_reg__
	st Z,__zero_reg__
	mov r20,r22
	rjmp .L78
.L79:
	movw r24,r18
	adiw r24,1
	movw r26,r18
	lsl r26
	rol r27
	add r26,r18
	adc r27,r19
	movw r30,r24
	lsl r30
	rol r31
	add r30,r24
	adc r31,r25
	subi r26,lo8(-(blocks))
	sbci r27,hi8(-(blocks))
	subi r30,lo8(-(blocks))
	sbci r31,hi8(-(blocks))
	ldi r24,lo8(3)
.L80:
	ld r0,Z+
	st X+,r0
	subi r24,lo8(-(-1))
	brne .L80
	subi r20,lo8(-(1))
.L78:
	mov r18,r20
	clr r19
	lds r24,activeBlocks
	clr r25
	sbiw r24,1
	cp r18,r24
	cpc r19,r25
	brlt .L79
	lds r24,activeBlocks
	subi r24,lo8(-(-1))
	sts activeBlocks,r24
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(1)
	ldi r25,hi8(1)
	ret
.L72:
	mov r22,r20
	lds r24,activeBlocks
	cp r20,r24
	brsh .+2
	rjmp .L73
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(0)
	ldi r25,hi8(0)
	ret
/* epilogue: frame size=0 */
/* epilogue: noreturn */
/* epilogue end (size=0) */
/* function memory_free_block size 99 (99) */
	.size	memory_free_block, .-memory_free_block
.global	queue_exists
	.type	queue_exists, @function
queue_exists:
/* prologue: frame size=0 */
/* prologue end (size=0) */
	movw r30,r24
	ldd r24,Z+1
	ldi r18,lo8(0)
	ldi r19,hi8(0)
	tst r24
	breq .L89
	ldi r18,lo8(1)
	ldi r19,hi8(1)
.L89:
	movw r24,r18
/* epilogue: frame size=0 */
	ret
/* epilogue end (size=1) */
/* function queue_exists size 10 (9) */
	.size	queue_exists, .-queue_exists
.global	queue_get_maximum_size
	.type	queue_get_maximum_size, @function
queue_get_maximum_size:
/* prologue: frame size=0 */
/* prologue end (size=0) */
	movw r30,r24
	ldd r24,Z+1
	clr r25
/* epilogue: frame size=0 */
	ret
/* epilogue end (size=1) */
/* function queue_get_maximum_size size 4 (3) */
	.size	queue_get_maximum_size, .-queue_get_maximum_size
.global	queue_get_free_size
	.type	queue_get_free_size, @function
queue_get_free_size:
/* prologue: frame size=0 */
/* prologue end (size=0) */
	movw r30,r24
	ldd r24,Z+1
	ldd r25,Z+2
	sub r24,r25
	clr r25
/* epilogue: frame size=0 */
	ret
/* epilogue end (size=1) */
/* function queue_get_free_size size 6 (5) */
	.size	queue_get_free_size, .-queue_get_free_size
.global	queue_get_mumber_of_messages
	.type	queue_get_mumber_of_messages, @function
queue_get_mumber_of_messages:
/* prologue: frame size=0 */
/* prologue end (size=0) */
	movw r30,r24
	ldd r24,Z+2
	clr r25
/* epilogue: frame size=0 */
	ret
/* epilogue end (size=1) */
/* function queue_get_mumber_of_messages size 4 (3) */
	.size	queue_get_mumber_of_messages, .-queue_get_mumber_of_messages
.global	queue_wait_for_message
	.type	queue_wait_for_message, @function
queue_wait_for_message:
/* prologue: frame size=0 */
/* prologue end (size=0) */
	movw r30,r24
	ldi r24,lo8(24)
	ldi r25,hi8(24)
	ldi r18,lo8(15)
/* #APP */
	in __tmp_reg__,__SREG__
	cli
	wdr
	sts 96,r24
	out __SREG__,__tmp_reg__
	sts 96,r18
	
/* #NOAPP */
	lds r24,110
	ori r24,lo8(1)
	sts 110,r24
/* #APP */
	sei
/* #NOAPP */
	ldd r24,Z+1
	tst r24
	brne .L104
	ldi r24,lo8(0)
	ldi r25,hi8(0)
	ret
.L101:
	ldi r24,lo8(-1)
	out 70-0x20,r24
.L104:
	ldd r24,Z+2
	tst r24
	breq .L101
	ldi r24,lo8(1)
	ldi r25,hi8(1)
	ret
/* epilogue: frame size=0 */
/* epilogue: noreturn */
/* epilogue end (size=0) */
/* function queue_wait_for_message size 39 (39) */
	.size	queue_wait_for_message, .-queue_wait_for_message
.global	queue_read_byte
	.type	queue_read_byte, @function
queue_read_byte:
/* prologue: frame size=0 */
	push r16
	push r17
	push r28
	push r29
/* prologue end (size=4) */
	movw r28,r24
	in r24,95-0x20
	sts sregsys,r24
/* #APP */
	cli
/* #NOAPP */
	ldd r24,Y+2
	tst r24
	breq .L106
	ldd r24,Y+2
	cp r22,r24
	brsh .L106
	ld r24,Y
	cpi r24,lo8(1)
	breq .L109
.L106:
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(0)
	ldi r25,hi8(0)
	rjmp .L110
.L109:
	ldd r30,Y+5
	ldd r31,Y+6
	add r30,r22
	adc r31,__zero_reg__
	ld r21,Z
	tst r20
	breq .L111
	rjmp .L113
.L114:
	ldd r16,Y+5
	ldd r17,Y+6
	add r16,r18
	adc r17,r19
	ldd r26,Y+5
	ldd r27,Y+6
	add r26,r18
	adc r27,r19
	movw r30,r26
	ldd r24,Z+1
	movw r30,r16
	st Z,r24
	subi r22,lo8(-(1))
.L113:
	ldd r24,Y+2
	mov r18,r22
	clr r19
	clr r25
	sbiw r24,1
	cp r18,r24
	cpc r19,r25
	brlt .L114
	ldd r24,Y+2
	subi r24,lo8(-(-1))
	std Y+2,r24
.L111:
	lds r24,sregsys
	out 95-0x20,r24
	mov r24,r21
	clr r25
.L110:
/* epilogue: frame size=0 */
	pop r29
	pop r28
	pop r17
	pop r16
	ret
/* epilogue end (size=5) */
/* function queue_read_byte size 67 (58) */
	.size	queue_read_byte, .-queue_read_byte
.global	queue_read_item
	.type	queue_read_item, @function
queue_read_item:
/* prologue: frame size=0 */
	push r12
	push r13
	push r14
	push r15
	push r16
	push r17
	push r28
	push r29
/* prologue end (size=8) */
	movw r28,r24
	movw r16,r22
	mov r25,r20
	mov r14,r18
	in r24,95-0x20
	sts sregsys,r24
/* #APP */
	cli
/* #NOAPP */
	ld r20,Y
	ldd r24,Y+2
	tst r24
	breq .L118
	mul r25,r20
	mov r15,r0
	clr r1
	ldd r24,Y+2
	cp r15,r24
	brsh .L118
	or r22,r23
	breq .L118
	mov r20,r15
	mov r22,r15
	clr r23
	rjmp .L122
.L118:
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(0)
	ldi r25,hi8(0)
	rjmp .L123
.L124:
	movw r26,r18
	sub r26,r22
	sbc r27,r23
	tst r14
	breq .L125
	add r26,r16
	adc r27,r17
	ldd r30,Y+5
	ldd r31,Y+6
	add r30,r22
	adc r31,r23
	ld r24,Z
	st X,r24
	mov r21,r15
	rjmp .L127
.L128:
	ldd r12,Y+5
	ldd r13,Y+6
	add r12,r18
	adc r13,r19
	ldd r26,Y+5
	ldd r27,Y+6
	add r26,r18
	adc r27,r19
	movw r30,r26
	ldd r24,Z+1
	movw r30,r12
	st Z,r24
	subi r21,lo8(-(1))
.L127:
	ldd r24,Y+2
	mov r18,r21
	clr r19
	clr r25
	sbiw r24,1
	cp r18,r24
	cpc r19,r25
	brlt .L128
	ldd r24,Y+2
	subi r24,lo8(-(-1))
	std Y+2,r24
	rjmp .L130
.L125:
	add r26,r16
	adc r27,r17
	ldd r30,Y+5
	ldd r31,Y+6
	add r30,r18
	adc r31,r19
	ld r24,Z
	st X,r24
.L130:
	subi r20,lo8(-(1))
.L122:
	mov r18,r20
	clr r19
	ld r24,Y
	movw r30,r22
	add r30,r24
	adc r31,__zero_reg__
	cp r18,r30
	cpc r19,r31
	brlt .L124
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(1)
	ldi r25,hi8(1)
.L123:
/* epilogue: frame size=0 */
	pop r29
	pop r28
	pop r17
	pop r16
	pop r15
	pop r14
	pop r13
	pop r12
	ret
/* epilogue end (size=9) */
/* function queue_read_item size 111 (94) */
	.size	queue_read_item, .-queue_read_item
.global	queue_read_pointer
	.type	queue_read_pointer, @function
queue_read_pointer:
/* prologue: frame size=0 */
/* prologue end (size=0) */
	movw r30,r24
	ldd r24,Z+3
	ldd r25,Z+4
/* epilogue: frame size=0 */
	ret
/* epilogue end (size=1) */
/* function queue_read_pointer size 4 (3) */
	.size	queue_read_pointer, .-queue_read_pointer
.global	queue_write_byte
	.type	queue_write_byte, @function
queue_write_byte:
/* prologue: frame size=0 */
	push r28
	push r29
/* prologue end (size=2) */
	movw r26,r24
	in r24,95-0x20
	sts sregsys,r24
/* #APP */
	cli
/* #NOAPP */
	movw r28,r26
	ldd r18,Y+2
	ldd r24,Y+1
	clr r19
	clr r25
	sbiw r24,1
	cp r24,r18
	cpc r25,r19
	brlt .L136
	ld r24,X
	cpi r24,lo8(1)
	breq .L138
.L136:
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(0)
	ldi r25,hi8(0)
	rjmp .L139
.L138:
	movw r28,r26
	ldd r30,Y+5
	ldd r31,Y+6
	add r30,r18
	adc r31,r19
	st Z,r22
	ldd r24,Y+2
	subi r24,lo8(-(1))
	std Y+2,r24
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(1)
	ldi r25,hi8(1)
.L139:
/* epilogue: frame size=0 */
	pop r29
	pop r28
	ret
/* epilogue end (size=3) */
/* function queue_write_byte size 43 (38) */
	.size	queue_write_byte, .-queue_write_byte
.global	button_press_12
	.type	button_press_12, @function
button_press_12:
/* prologue: frame size=0 */
/* prologue end (size=0) */
	sbic 35-0x20,1
	rjmp .L142
	lds r24,107
	andi r24,lo8(-3)
	sts 107,r24
	ldi r22,lo8(1)
	ldi r24,lo8(time_calc_queue)
	ldi r25,hi8(time_calc_queue)
	call queue_write_byte
	ret
.L142:
	sbic 35-0x20,2
	rjmp .L146
	lds r24,107
	andi r24,lo8(-5)
	sts 107,r24
	ldi r22,lo8(2)
	ldi r24,lo8(time_calc_queue)
	ldi r25,hi8(time_calc_queue)
	call queue_write_byte
.L146:
	ret
/* epilogue: frame size=0 */
/* epilogue: noreturn */
/* epilogue end (size=0) */
/* function button_press_12 size 26 (26) */
	.size	button_press_12, .-button_press_12
.global	__vector_3
	.type	__vector_3, @function
__vector_3:
/* prologue: frame size=0 */
	push __zero_reg__
	push __tmp_reg__
	in __tmp_reg__,__SREG__
	push __tmp_reg__
	clr __zero_reg__
	push r18
	push r19
	push r20
	push r21
	push r22
	push r23
	push r24
	push r25
	push r26
	push r27
	push r30
	push r31
/* prologue end (size=17) */
	call button_press_12
/* epilogue: frame size=0 */
	pop r31
	pop r30
	pop r27
	pop r26
	pop r25
	pop r24
	pop r23
	pop r22
	pop r21
	pop r20
	pop r19
	pop r18
	pop __tmp_reg__
	out __SREG__,__tmp_reg__
	pop __tmp_reg__
	pop __zero_reg__
	reti
/* epilogue end (size=17) */
/* function __vector_3 size 36 (2) */
	.size	__vector_3, .-__vector_3
.global	tick_time
	.type	tick_time, @function
tick_time:
/* prologue: frame size=0 */
/* prologue end (size=0) */
	lds r24,zaehler.1829
	subi r24,lo8(-(1))
	sts zaehler.1829,r24
	cpi r24,lo8(122)
	brne .L150
	sts zaehler.1829,__zero_reg__
	ldi r22,lo8(-128)
	ldi r24,lo8(time_calc_queue)
	ldi r25,hi8(time_calc_queue)
	call queue_write_byte
	ret
.L150:
	ldi r22,lo8(30)
	call __udivmodqi4
	tst r25
	brne .L154
	lds r24,107
	ori r24,lo8(2)
	sts 107,r24
	lds r24,107
	ori r24,lo8(4)
	sts 107,r24
.L154:
	ret
/* epilogue: frame size=0 */
/* epilogue: noreturn */
/* epilogue end (size=0) */
/* function tick_time size 31 (31) */
	.size	tick_time, .-tick_time
.global	__vector_9
	.type	__vector_9, @function
__vector_9:
/* prologue: frame size=0 */
	push __zero_reg__
	push __tmp_reg__
	in __tmp_reg__,__SREG__
	push __tmp_reg__
	clr __zero_reg__
	push r18
	push r19
	push r20
	push r21
	push r22
	push r23
	push r24
	push r25
	push r26
	push r27
	push r30
	push r31
/* prologue end (size=17) */
	call tick_time
/* epilogue: frame size=0 */
	pop r31
	pop r30
	pop r27
	pop r26
	pop r25
	pop r24
	pop r23
	pop r22
	pop r21
	pop r20
	pop r19
	pop r18
	pop __tmp_reg__
	out __SREG__,__tmp_reg__
	pop __tmp_reg__
	pop __zero_reg__
	reti
/* epilogue end (size=17) */
/* function __vector_9 size 36 (2) */
	.size	__vector_9, .-__vector_9
.global	time_calc
	.type	time_calc, @function
time_calc:
/* prologue: frame size=0 */
	push r10
	push r11
	push r12
	push r13
	push r15
	push r16
	push r17
	push r28
	push r29
/* prologue end (size=9) */
	clr r15
	ldi r17,lo8(0)
	ldi r16,lo8(0)
	ldi r28,lo8(time_calc_queue)
	ldi r29,hi8(time_calc_queue)
	ldi r23,lo8(minutes_queue)
	mov r10,r23
	ldi r23,hi8(minutes_queue)
	mov r11,r23
	ldi r22,lo8(hours_queue)
	mov r12,r22
	ldi r22,hi8(hours_queue)
	mov r13,r22
.L158:
	movw r24,r28
	call queue_wait_for_message
	ldi r20,lo8(1)
	ldi r22,lo8(0)
	movw r24,r28
	call queue_read_byte
	cpi r24,lo8(1)
	brne .L159
	ldi r24,lo8(22)
	cp r24,r15
	brsh .L161
	clr r15
	rjmp .L163
.L161:
	inc r15
	rjmp .L163
.L159:
	cpi r24,lo8(2)
	brne .L164
	cpi r17,lo8(59)
	brlo .L166
	ldi r17,lo8(0)
	rjmp .L163
.L166:
	subi r17,lo8(-(1))
	rjmp .L163
.L164:
	in r24,95-0x20
	sts sreg,r24
	ldi r24,lo8(24)
/* #APP */
	in __tmp_reg__, __SREG__
	cli
	sts 96, r24
	sts 96, __zero_reg__
	out __SREG__,__tmp_reg__
	
	cli
/* #NOAPP */
	subi r16,lo8(-(1))
	cpi r16,lo8(60)
	brne .L168
	subi r17,lo8(-(1))
	cpi r17,lo8(60)
	brne .L175
	inc r15
	ldi r24,lo8(24)
	cp r15,r24
	brne .L172
	clr r15
.L172:
	ldi r17,lo8(0)
.L175:
	ldi r16,lo8(0)
.L168:
/* #APP */
	sei
/* #NOAPP */
	ldi r24,lo8(24)
	ldi r25,hi8(24)
	ldi r18,lo8(15)
/* #APP */
	in __tmp_reg__,__SREG__
	cli
	wdr
	sts 96,r24
	out __SREG__,__tmp_reg__
	sts 96,r18
	
/* #NOAPP */
	lds r24,sreg
	out 95-0x20,r24
.L163:
	mov r22,r17
	movw r24,r10
	call queue_write_byte
	mov r22,r15
	movw r24,r12
	call queue_write_byte
	rjmp .L158
/* epilogue: frame size=0 */
/* epilogue: noreturn */
/* epilogue end (size=0) */
/* function time_calc size 109 (100) */
	.size	time_calc, .-time_calc
.global	queue_write_item
	.type	queue_write_item, @function
queue_write_item:
/* prologue: frame size=0 */
	push r16
	push r17
	push r28
	push r29
/* prologue end (size=4) */
	movw r26,r24
	movw r16,r22
	in r24,95-0x20
	sts sregsys,r24
/* #APP */
	cli
/* #NOAPP */
	movw r28,r26
	ldd r18,Y+2
	ld r22,X
	ldd r24,Y+1
	mov r20,r18
	clr r21
	movw r18,r20
	add r18,r22
	adc r19,__zero_reg__
	clr r25
	cp r24,r18
	cpc r25,r19
	brlt .L177
	movw r18,r20
	ldi r25,lo8(0)
	rjmp .L179
.L177:
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(0)
	ldi r25,hi8(0)
	rjmp .L180
.L181:
	movw r28,r26
	ldd r30,Y+5
	ldd r31,Y+6
	add r30,r18
	adc r31,r19
	movw r28,r16
	ld r24,Y+
	movw r16,r28
	st Z,r24
	movw r30,r26
	ldd r24,Z+2
	subi r24,lo8(-(1))
	std Z+2,r24
	subi r25,lo8(-(1))
	subi r18,lo8(-(1))
	sbci r19,hi8(-(1))
.L179:
	cp r25,r22
	brne .L181
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(1)
	ldi r25,hi8(1)
.L180:
/* epilogue: frame size=0 */
	pop r29
	pop r28
	pop r17
	pop r16
	ret
/* epilogue end (size=5) */
/* function queue_write_item size 61 (52) */
	.size	queue_write_item, .-queue_write_item
.global	queue_write_pointer
	.type	queue_write_pointer, @function
queue_write_pointer:
/* prologue: frame size=0 */
/* prologue end (size=0) */
	movw r30,r24
	in r24,95-0x20
	sts sregsys,r24
/* #APP */
	cli
/* #NOAPP */
	cp r22,__zero_reg__
	cpc r23,__zero_reg__
	brne .L185
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(0)
	ldi r25,hi8(0)
	ret
.L185:
	std Z+4,r23
	std Z+3,r22
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(1)
	ldi r25,hi8(1)
	ret
/* epilogue: frame size=0 */
/* epilogue: noreturn */
/* epilogue end (size=0) */
/* function queue_write_pointer size 23 (23) */
	.size	queue_write_pointer, .-queue_write_pointer
.global	queue_anhilate
	.type	queue_anhilate, @function
queue_anhilate:
/* prologue: frame size=0 */
	push r28
	push r29
/* prologue end (size=2) */
	movw r28,r24
	in r24,95-0x20
	sts sregsys,r24
/* #APP */
	cli
/* #NOAPP */
	ldd r24,Y+5
	ldd r25,Y+6
	or r24,r25
	brne .L190
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(0)
	ldi r25,hi8(0)
	rjmp .L192
.L190:
	ldd r24,Y+5
	ldd r25,Y+6
	call free
	std Y+6,__zero_reg__
	std Y+5,__zero_reg__
	std Y+2,__zero_reg__
	std Y+1,__zero_reg__
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(1)
	ldi r25,hi8(1)
.L192:
/* epilogue: frame size=0 */
	pop r29
	pop r28
	ret
/* epilogue end (size=3) */
/* function queue_anhilate size 34 (29) */
	.size	queue_anhilate, .-queue_anhilate
.global	queue_init
	.type	queue_init, @function
queue_init:
/* prologue: frame size=0 */
	push r16
	push r17
	push r28
	push r29
/* prologue end (size=4) */
	movw r28,r24
	mov r17,r22
	mov r16,r20
	in r24,95-0x20
	sts sregsys,r24
/* #APP */
	cli
/* #NOAPP */
	tst r22
	breq .L204
	tst r20
	breq .L204
	cpi r22,lo8(3)
	brsh .L204
	mul r20,r22
	movw r24,r0
	clr r1
	call malloc
	std Y+6,r25
	std Y+5,r24
	ldd r24,Y+5
	ldd r25,Y+6
	or r24,r25
	breq .L200
	ldd r18,Y+5
	ldd r19,Y+6
	in r24,93-0x20
	in r25,(93)+1-0x20
	cp r24,r18
	cpc r25,r19
	brsh .L202
.L200:
	std Y+1,__zero_reg__
.L204:
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(0)
	ldi r25,hi8(0)
	rjmp .L199
.L202:
	mul r16,r17
	mov r24,r0
	clr r1
	std Y+1,r24
	st Y,r16
	std Y+4,__zero_reg__
	std Y+3,__zero_reg__
	lds r24,sregsys
	out 95-0x20,r24
	ldi r24,lo8(1)
	ldi r25,hi8(1)
.L199:
/* epilogue: frame size=0 */
	pop r29
	pop r28
	pop r17
	pop r16
	ret
/* epilogue end (size=5) */
/* function queue_init size 60 (51) */
	.size	queue_init, .-queue_init
.global	main
	.type	main, @function
main:
/* prologue: frame size=0 */
	ldi r28,lo8(__stack - 0)
	ldi r29,hi8(__stack - 0)
	out __SP_H__,r29
	out __SP_L__,r28
/* prologue end (size=4) */
	ldi r20,lo8(255)
	ldi r21,hi8(255)
	ldi r22,lo8(pm(idle))
	ldi r23,hi8(pm(idle))
	ldi r24,lo8(idletask)
	ldi r25,hi8(idletask)
	call task_insert
	ldi r24,lo8(24)
	ldi r25,hi8(24)
	ldi r18,lo8(15)
/* #APP */
	in __tmp_reg__,__SREG__
	cli
	wdr
	sts 96,r24
	out __SREG__,__tmp_reg__
	sts 96,r18
	
/* #NOAPP */
	ldi r20,lo8(255)
	ldi r21,hi8(255)
	ldi r22,lo8(pm(display_minutes))
	ldi r23,hi8(pm(display_minutes))
	ldi r24,lo8(display_minutes_task)
	ldi r25,hi8(display_minutes_task)
	call task_insert
	ldi r20,lo8(255)
	ldi r21,hi8(255)
	ldi r22,lo8(pm(display_hours))
	ldi r23,hi8(pm(display_hours))
	ldi r24,lo8(display_hours_task)
	ldi r25,hi8(display_hours_task)
	call task_insert
	ldi r20,lo8(255)
	ldi r21,hi8(255)
	ldi r22,lo8(pm(time_calc))
	ldi r23,hi8(pm(time_calc))
	ldi r24,lo8(time_calc_task)
	ldi r25,hi8(time_calc_task)
	call task_insert
	ldi r20,lo8(1)
	ldi r22,lo8(1)
	ldi r24,lo8(minutes_queue)
	ldi r25,hi8(minutes_queue)
	call queue_init
	ldi r20,lo8(1)
	ldi r22,lo8(1)
	ldi r24,lo8(time_calc_queue)
	ldi r25,hi8(time_calc_queue)
	call queue_init
	ldi r20,lo8(1)
	ldi r22,lo8(2)
	ldi r24,lo8(hours_queue)
	ldi r25,hi8(hours_queue)
	call queue_init
	ldi r24,lo8(-1)
	out 39-0x20,r24
	out 42-0x20,r24
	ldi r24,lo8(6)
	sts 177,r24
	ldi r25,lo8(1)
	sts 112,r25
	out 37-0x20,r24
	sts 104,r25
	sts 107,r24
	call task_schedule
.L206:
	rjmp .L206
/* epilogue: frame size=0 */
/* epilogue: noreturn */
/* epilogue end (size=0) */
/* function main size 88 (84) */
	.size	main, .-main
.global	display_minutes
	.type	display_minutes, @function
display_minutes:
/* prologue: frame size=0 */
	push r16
	push r17
	push r28
	push r29
/* prologue end (size=4) */
	lds r24,minutes_queue+1
	tst r24
	breq .L209
	lds r24,activeBlocks
	cpi r24,lo8(2)
	brne .L212
.L209:
	ldi r24,lo8(display_minutes_task)
	ldi r25,hi8(display_minutes_task)
	call task_remove
.L212:
	call memory_allocate_block
	movw r28,r24
	ldi r16,lo8(minutes_queue)
	ldi r17,hi8(minutes_queue)
.L213:
	movw r24,r16
	call queue_wait_for_message
	ldi r20,lo8(1)
	ldi r22,lo8(0)
	movw r24,r16
	call queue_read_byte
	st Y,r24
	out 43-0x20,r24
	rjmp .L213
/* epilogue: frame size=0 */
/* epilogue: noreturn */
/* epilogue end (size=0) */
/* function display_minutes size 32 (28) */
	.size	display_minutes, .-display_minutes
.global	display_hours
	.type	display_hours, @function
display_hours:
/* prologue: frame size=0 */
	push r16
	push r17
	push r28
	push r29
/* prologue end (size=4) */
	lds r24,hours_queue+1
	tst r24
	breq .L217
	lds r24,activeBlocks
	cpi r24,lo8(2)
	brne .L220
.L217:
	ldi r24,lo8(display_hours_task)
	ldi r25,hi8(display_hours_task)
	call task_remove
.L220:
	call memory_allocate_block
	movw r28,r24
	ldi r16,lo8(hours_queue)
	ldi r17,hi8(hours_queue)
.L221:
	movw r24,r16
	call queue_wait_for_message
	ldi r20,lo8(1)
	ldi r22,lo8(0)
	movw r24,r16
	call queue_read_byte
	st Y,r24
	out 40-0x20,r24
	rjmp .L221
/* epilogue: frame size=0 */
/* epilogue: noreturn */
/* epilogue end (size=0) */
/* function display_hours size 32 (28) */
	.size	display_hours, .-display_hours
	.lcomm sregsys,1
	.data
	.type	active_task_id, @object
	.size	active_task_id, 1
active_task_id:
	.byte	-1
	.lcomm activeBlocks,1
	.lcomm active_task,2
	.lcomm zaehler.1829,1
	.lcomm sreg,1
	.lcomm data,4
	.lcomm blocks,6
	.lcomm task_container,8
	.comm stack_global,384,1
	.comm idletask,8,1
	.comm time_calc_task,8,1
	.comm display_minutes_task,8,1
	.comm display_hours_task,8,1
	.comm minutes_queue,7,1
	.comm hours_queue,7,1
	.comm time_calc_queue,7,1
/* File "nano_os.c": code 1588 = 0x0634 (1388), prologues 102, epilogues  98 */
